#Historiske frekvenser for faktorer med direkte paavirkning
lambda_1 = 0.1
lambda_2 = 0.2
lambda_3 = 0.15
lambda_h = lambda_1 + lambda_2 + lambda_3

#Sannsynligheter for de direkte faktorene basert paa historisk frekvens. 
p1 = 1 - exp(-lambda_1*(1/4))
p2 = 1 - exp(-lambda_2*(1/4))
p3 = 1 - exp(-lambda_3*(1/4))
ph = 1 - exp(-lambda_h*(1/4))

# Faktor for spredning av diskret fordeling for F5
R = 1 

# Korreksjonsfaktorer for aa beskrive spredning i sannsynlighet for direkte faktor aarsak til hendelse. BORA tilnaerming.
Q = c(0.5, 0.75, 1, 1.5, 2, 3) #vekter for aa beskrive forskjell A til F.

# sannsynlighetsfordeling for F4
P4 = c(0.05, 0.275, 0.35, 0.167, 0.108, 0.05)

# sannsynlighetsfordeling for F6
P6 = c(0.05, 0.275, 0.35, 0.167, 0.108, 0.05)

# Matrise for alle kombinasjoner av Zj'er for indirekte faktor med en forelder
Zj=array(dim=c(6,6))
for(n in 1:6) {
	for(a in 1:6) {
		Zj[n,a] = abs(n-a)
	}
}


#Betinget sannsynlighetsfordeling Pj for Fj med en forelder
Pj=array(dim = c(6,6))
for(n in 1:6) {
	for(a in 1:6) {
		sum = 0
		for(i in 1:6) {
			sum = sum + exp(-R*Zj[n,i])
		}
		Pj[n,a] = (exp(-R*Zj[n,a]))/(sum)
	}
}

# CPT for F1
Pb1 = p1/sum(P4*Q)
P1H = Q*Pb1
P1h = 1-P1H
P1 = c(1:12)
m=1
for (n in 1:6){	
	P1[m] = P1H[n]
	m = m+2
	}

m=2
for (n in 1:6){
	P1[m] = P1h[n]
	m = m+2
}

#CPT for F5
P5 = c(1:36)
k = 1
for(i in 1:6){
	for(j in  1:6){
		P5[k] = Pj[i,j]
		k = k+1
	}
}

# CPT for F3
Pb3 = p3/sum(P6*Q)
P3H = Q*Pb3
P3h = 1-P3H
P3 = c(1:12)
m=1
for (n in 1:6){	
	P3[m] = P3H[n]
	m = m+2
	}

m=2
for (n in 1:6){
	P3[m] = P3h[n]
	m = m+2
}

#Pi=P6

# CPT for F2
k = 1
temp = Pj *P6
Puj = c(1:6)
for(i in 1:6){
	Puj[i] = sum(temp[,i])
}

k = 1
temp = Pj *P6
Puj = c(1:6)
for(i in 1:6){
	Puj[i] = sum(temp[,i]) #beregner ubetinget fordeling for F5
}

Pb2 = p2/sum(Puj*Q)
P2H = Q*Pb2
P2h = 1-P2H
P2 = c(1:12)
m=1
for (n in 1:6){	
	P2[m] = P2H[n]
	m = m+2
	}

m=2
for (n in 1:6){
	P2[m] = P2h[n]
	m = m+2
}

# CPT for Hendelse
PHA = array(data = NA, dim = c(2,8))
PHA[1,1] = 1
PHA[1,2] = 1
PHA[1,3] = 1
PHA[1,4] = 1
PHA[1,5] = 1
PHA[1,6] = 1
PHA[1,7] = 1
PHA[1,8] = 0
PHA[2,1] = 0
PHA[2,2] = 0
PHA[2,3] = 0
PHA[2,4] = 0
PHA[2,5] = 0
PHA[2,6] = 0
PHA[2,7] = 0
PHA[2,8] = 1

PH = c(1:16)
k= 1
for(i in 1:8){
	for(j in 1:2){
		PH[k] = PHA[j,i]
		k = k + 1
	}
}

#CPT for indikatorer med indirekte paavirkning
Ii = array(dim=c(6,6))
Ii[1,1] = 0.6
Ii[2,1] = 0.16
Ii[3,1] = 0.12
Ii[4,1] = 0.06
Ii[5,1] = 0.04
Ii[6,1] = 0.02
Ii[1,2] = 0.12
Ii[2,2] = 0.6
Ii[3,2] = 0.12
Ii[4,2] = 0.07
Ii[5,2] = 0.05
Ii[6,2] = 0.04
Ii[1,3] = 0.075
Ii[2,3] = 0.1
Ii[3,3] = 0.6
Ii[4,3] = 0.1
Ii[5,3] = 0.075
Ii[6,3] = 0.05
Ii[1,4] = 0.05
Ii[2,4] = 0.075
Ii[3,4] = 0.1
Ii[4,4] = 0.6
Ii[5,4] = 0.1
Ii[6,4] = 0.075
Ii[1,5] = 0.04
Ii[2,5] = 0.05
Ii[3,5] = 0.07
Ii[4,5] = 0.12
Ii[5,5] = 0.6
Ii[6,5] = 0.12
Ii[1,6] = 0.02
Ii[2,6] = 0.04
Ii[3,6] = 0.06
Ii[4,6] = 0.12
Ii[5,6] = 0.16
Ii[6,6] = 0.6

PIi= c(1:36)
k = 1
for(i in 1:6){
	for(j in  1:6){
		PIi[k] = Ii[j,i]
		k = k+1
	}
}

#CPT for indikatorer til faktorer med direkte paavirkning
# Id = array(dim=c(6,2))
# Id[1,1] = 0.05
# Id[2,1] = 0.07
# Id[3,1] = 0.12
# Id[4,1] = 0.2
# Id[5,1] = 0.26
# Id[6,1] = 0.3
# Id[1,2] = 0.3
# Id[2,2] = 0.26
# Id[3,2] = 0.2
# Id[4,2] = 0.12
# Id[5,2] = 0.07
# Id[6,2] = 0.05

Id = array(dim=c(6,2))
Id[1,1] = 0.1
Id[2,1] = 0.14
Id[3,1] = 0.16
Id[4,1] = 0.18
Id[5,1] = 0.20
Id[6,1] = 0.22
Id[1,2] = 0.22
Id[2,2] = 0.20
Id[3,2] = 0.18
Id[4,2] = 0.16
Id[5,2] = 0.14
Id[6,2] = 0.10

PId= c(1:12)
k = 1
for(i in 1:2){
	for(j in  1:6){
		PId[k] = Id[j,i]
		k = k+1
	}
}

#Beskriver bayesiansk nettverk
library(gRain)

level = c("A", "B", "C", "D", "E", "F") # Tilstander til en indirekte faktor
level_d = c("Hendelse", "Ikke hendelse") # Tilstander til en faktor med direkte paavirkning

F6 = cptable(~F6, values = P6, levels = level)
F5 = cptable(~F5 | F6, values = P5, levels = level)
F4 = cptable(~F4, values = P4, levels = level)
F3 = cptable(~F3 | F6, values = P3, levels = level_d)
F2 = cptable(~F2 | F5, values = P2, levels = level_d)
F1 = cptable(~F1 | F4, values = P1, levels = level_d)
H = cptable(~H | F1 : F2 : F3, values = PH, levels = level_d)

I1 = cptable(~I1 | F1, values = PId, levels = level)
I2 = cptable(~I2 | F2, values = PId, levels = level)
I3 = cptable(~I3 | F3, values = PId, levels = level)
I4 = cptable(~I4 | F4, values = PIi, levels = level)
I5 = cptable(~I5 | F5, values = PIi, levels = level)
I6 = cptable(~I6 | F6, values = PIi, levels = level)

plist = compileCPT(list(F6, F5, F4, F3, F2, F1, H, I6, I1, I2, I3, I4, I5))
net = grain(plist)

saveHuginNet(net, "faktormodel.net") #lager HUGIN-fil av "net"